import numpy as np
import sklearn.datasets as samples_generator
from sklearn import model_selection
from sklearn import metrics
import sklearn.svm as svm
import pandas as pd 

parametros = { 'C': [0.001, 0.01, 0.1, 1.0 , 10.0, 100.0],
           'gamma': [0.001, 0.01, 0.1, 1.0 , 10.0, 100.0] }


X, y = samples_generator.make_circles( n_samples=200, noise=0.1, factor=0.35, random_state=9 )
# print( X.shape )
# print( y )

# Separamos los datos de entrenamiento y de prueba
Xentrena, Xvalida, yentrena, yvalida = model_selection.train_test_split( X, y, test_size = 0.2, random_state = 20 )

busqueda_malla = model_selection.GridSearchCV( svm.SVC(), parametros, cv=5 )

busqueda_malla.fit( Xentrena, yentrena )

print( "Exactitud en la evaluación" )
print( busqueda_malla.score( Xvalida, yvalida ) )

print( "Mejores parámetros" )
print( busqueda_malla.best_params_ ) 

print( "Mejor exactitud de la VC" )
print( busqueda_malla.best_score_ ) 

print( "Mejor modelo" )
print( busqueda_malla.best_estimator_ ) 

resultados = pd.DataFrame( busqueda_malla.cv_results_ )
r = np.array( resultados.mean_test_score ).reshape( 6, 6 ) 
np.savetxt("r.txt", r )

